import { IEditorServices } from '@jupyterlab/codeeditor';
import { ICodeSnippet } from './CodeSnippetContentsService';
import { ReactWidget, WidgetTracker } from '@jupyterlab/apputils';
import React from 'react';
import { Message } from '@lumino/messaging';
import { CodeSnippetContentsService } from './CodeSnippetContentsService';
import { CodeSnippetWidget } from './CodeSnippetWidget';
export declare class CodeSnippetEditor extends ReactWidget {
    editorServices: IEditorServices;
    private editor;
    private saved;
    private oldCodeSnippetName;
    private _codeSnippet;
    private _hasRefreshedSinceAttach;
    contentsService: CodeSnippetContentsService;
    codeSnippetWidget: CodeSnippetWidget;
    tracker: WidgetTracker;
    constructor(contentsService: CodeSnippetContentsService, editorServices: IEditorServices, tracker: WidgetTracker, codeSnippetWidget: CodeSnippetWidget, args: ICodeSnippet);
    get codeSnippet(): ICodeSnippet;
    private deactivateEditor;
    private deactivateNameField;
    private deactivateDescriptionField;
    private activeFieldState;
    onUpdateRequest(msg: Message): void;
    onAfterAttach(msg: Message): void;
    onAfterShow(msg: Message): void;
    /**
     * Initial focus on the editor when it gets activated!
     * @param msg
     */
    onActivateRequest(msg: Message): void;
    onCloseRequest(msg: Message): void;
    /**
     * Visualize the editor more look like an editor
     * @param event
     */
    activateCodeMirror(event: React.MouseEvent<HTMLDivElement, MouseEvent>): void;
    deactivateCodeMirror(editor: Element): void;
    handleInputFieldChange(event: React.ChangeEvent<HTMLInputElement>): void;
    saveChange(event: React.MouseEvent<HTMLElement, MouseEvent>): void;
    updateSnippet(): Promise<void>;
    /**
     * TODO: clean CSS style class - "Use constant"
     */
    renderCodeInput(): React.ReactElement;
    render(): React.ReactElement;
}
